function nel = netmesh(mp,port)

dispNodeNumbers = true;
%% Choose mesh resoultion
%mp =  multiplier (1, 1.5, 2, 2.5, 3, ...)
% Section 1
nr_1 = 16*mp(1);
nz_1 = 2*mp(2);
% Section 2
nr_2 = nr_1;
nz_2 = 2*mp(2);

nnod = nr_1*(nz_1+2)+nr_2*nz_2+1;
nel = nr_1*(nz_1+1)*2+nr_2*nz_2*2+nr_2;
N_H = nr_1;
N_V = nz_1 + nz_2+1;

%% Cage dimensions
radius = 25.0;
depth_1 = 0.5;
depth_2 = 17.5;
depth_3 = 30;

%% Meshing routine nodes
nodes = zeros(nnod, 3);
row = 0;

fid = fopen('cageinput\NetNode_Mooring.xml','w');
fprintf(fid,'%d\n', nnod);
% Section 1
for i = 1:(nz_1+2)
    Z = depth_1 + (depth_2-depth_1)*(i-1)/(nz_1+1);
   for j = 1:nr_1
        row = row+1;
        TH = 2*pi*(j-1)/nr_1;
        [X, Y] = pol2cart(TH, radius);
        
        nodes(row,:) = [X Y Z];  
        fprintf(fid,'%f,%f,%f\n', nodes(row,:));
   end
end

% Section 2
for i = 1:nz_2
    R = radius*(nz_2+1-i)/(nz_2+1);
    Z = depth_2 + (depth_3-depth_2)*i/(nz_2+1);
   for j = 1:nr_2
        row = row+1;
        TH = 2*pi*(j-1)/nr_2;
        [X, Y] = pol2cart(TH, R);
        nodes(row,:) = [X Y Z];  
        fprintf(fid,'%f,%f,%f\n', nodes(row,:));
   end
end
% Bottom node
nodes(row+1,:) = [0 0 depth_3];
fprintf(fid,'%f,%f,%f\n', nodes(row+1,:));

% Connections
fprintf(fid,'%d\n', nr_1);
collar_nodes = 0:(nr_1-1);
incr = (length(collar_nodes))/nr_1;
ToCollarNetConnectNodes = zeros(1,nr_1);
k = 0;
if incr == int64(incr)
    for i = 1:incr:length(collar_nodes)
        fprintf(fid,'%d\n', collar_nodes(i));
        k = k+1;
        if k>nr_1
            break
        end
        ToCollarNetConnectNodes(k) = collar_nodes(i); 
    end
else
    for i = 1:floor(incr*2):(length(collar_nodes)-1)
        fprintf(fid,'%d\n', collar_nodes(i));
        k = k+1;
        ToCollarNetConnectNodes(k) = collar_nodes(i);
        fprintf(fid,'%d\n', collar_nodes(i+1));
        k = k+1;
        if k>nr_1
            break
        end
        ToCollarNetConnectNodes(k) = collar_nodes(i+1);      
    end
end
fprintf(fid,'%d\n', nr_2);
bottomRing_nodes = (nz_1+1)*nr_2:((nz_1+1)*nr_2+(nr_2-1));
if incr == int64(incr)
    for i = 1:incr:length(bottomRing_nodes)
        fprintf(fid,'%d\n', bottomRing_nodes(i));
    end
else
    for i = 1:ceil(incr*2):(length(bottomRing_nodes)-1)
        fprintf(fid,'%d\n', bottomRing_nodes(i));
        fprintf(fid,'%d\n', bottomRing_nodes(i+1));
    end
end
fprintf(fid,'%d\n', nnod-1);
fclose(fid);

%% Meshing routine elements
% Section 1
row = 0;
elem = zeros(nel,3);
for i = 1:nz_1+1
   for j = 1:(nr_1-1)
    row = row + 1;
    elem(row,1) = i*nr_1 + j;
    elem(row,2) = (i-1)*nr_1 + j;
    elem(row,3) = (i-1)*nr_1 + j-1;
    
    row = row + 1;
    
    elem(row,1) = (i-1)*nr_1 + j-1;
    elem(row,2) = i*nr_1 + j-1;
    elem(row,3) = i*nr_1 + j;
   end
    j = nr_1;
    
    row = row + 1;
    
    elem(row,1) = (i-1)*nr_1 + j;
    elem(row,2) = i*nr_1 - j; 
    elem(row,3) = (i-1)*nr_1 + j-1;
    
    row = row + 1;
    elem(row,1) = (i-1)*nr_1 + j-1;
    elem(row,2) = i*nr_1 + j-1;
    elem(row,3) = (i-1)*nr_1 + j;

end
% Section 2
for i = 1:nz_2
   for j = 1:(nr_2-1)
    row = row + 1;
    elem(row,1) = i*nr_2 + j + nr_1*(nz_1+1);
    elem(row,2) = (i-1)*nr_2 + j + nr_1*(nz_1+1);
    elem(row,3) = (i-1)*nr_2 + j-1 + nr_1*(nz_1+1);
    
    row = row + 1;
    elem(row,1) = (i-1)*nr_2 + j-1 + nr_1*(nz_1+1);
    elem(row,2) = i*nr_2 + j-1 + nr_1*(nz_1+1);
    elem(row,3) = i*nr_2 + j + nr_1*(nz_1+1);
    
   end
    j = nr_2;
    
    row = row + 1;
    elem(row,1) = (i-1)*nr_2 + j + nr_1*(nz_1+1);
    elem(row,2) = i*nr_2 - j + nr_1*(nz_1+1);
    elem(row,3) = (i-1)*nr_2 + j-1 + nr_1*(nz_1+1);
    
    row = row + 1;
    elem(row,1) = (i-1)*nr_2 + j-1 + nr_1*(nz_1+1);
    elem(row,2) = i*nr_2 + j-1 + nr_1*(nz_1+1);    
    elem(row,3) = (i-1)*nr_2 + j + nr_1*(nz_1+1);
    
end
% Section 3
for j = 1:(nr_2-1)
    row = row + 1;
    elem(row,1) = nr_2 + nr_1*(nz_1+1)+nr_2*nz_2;
    elem(row,2) = j + nr_1*(nz_1+1)+nr_2*nz_2;    
    elem(row,3) = j-1 + nr_1*(nz_1+1)+nr_2*nz_2;

end
    j = nr_2;
    row = row + 1;
    elem(row,1) = nr_2 + nr_1*(nz_1+1)+nr_2*nz_2;
    elem(row,2) = nr_2-j + nr_1*(nz_1+1)+nr_2*nz_2;
    elem(row,3) = j-1 + nr_1*(nz_1+1)+nr_2*nz_2;
    
nel = length(elem);

fid = fopen('cageinput\NetMesh_Mooring.xml','w');
fprintf(fid,'%d\n', nel);
for i = 1:nel
    fprintf(fid,'%d,%d,%d\n', elem(i,:));
end
fclose(fid);
end